//***************************************************************************
//
//  ̧......: Fan_functions.c
//  ......: ATMEL Finland
//  ړIΏ..: ATmega169
//  ߲....: IAR EWAAVR 4.10B
//  ......: ̧݌ŗL֐
//  ......: 1.1
//
//  N   -   - 											- 
//  20050211 - 1.0 - 쐬											- KMe
//  20050330 - 1.1 - 										- KMe
//
//***************************************************************************

// ݸٰ ̧
#include <ioavr.h>
#include "main.h"
#include "Fan_functions.h"
#include "LCD_functions.h"
#include "USI_TWI_Master.h"
#include "BCD.h"

#define FALSE   0
#define TRUE    (!FALSE)

extern char gUSI;		// main.cgpS̕ϐ

//*****************************************************************************
//*
//* ֐	: FanScan
//* 	: char input (ޮè)
//* Ԃl	: char ST_state (ԋ@\pԔԍ)
//* ړI	: p\ȑŞ݂̑ƕ\
//*
//*****************************************************************************
char FanScan(char input)
{
  static char Cycle, Enter = 1;					// Ԍv, ׸
  static signed char FanTemp;					// ̧݉x
  static unsigned char FanNumber, FanRPS;		// ̧ݔԍ,̧݉]
  unsigned char CH, CL;							// Ɨp

  Delay(100);									// 100msx
  if (Enter)									/* 񏈗 */
  {
	LCD_Clear();								// LCDޯ̧
	LCD_UpdateRequired(TRUE, 0);				// LCD\XV(LCD󔒕\)
	FanNumber = 1;								// ̧ݔԍl
	FanTemp = 0;								// ̧݉xl
	FanRPS = 0;									// ̧݉]l
	Cycle = 1;									// Ԍv평(Jn)
	Enter = 0;									// ׸މ
  }

  if (input == KEY_PREV)						/* (ޮè) */
  {
	Enter = 1;									// ׸ސݒ
	return ST_STATUS;							// \ԍƋɕA
  }

  switch (Cycle)								/* ԍˑ */
  {
	case 1:
	  FanNumber = FanNext(FanNumber);			// ɗĻݔԍ擾
	  if (FanNumber)							// Ļ݂ŁA
	  {
		FanTemp = FanTemperature(FanNumber);	// Ή̧݉x()擾
		FanRPS = FanSpeed(FanNumber);			// Ή̧݉](RPS)擾
		LCD_putc(0, 'F');						// LCDޯ̧1'F'ݒ
		LCD_putc(1, 'A');						// LCDޯ̧2'A'ݒ
		LCD_putc(2, 'N');						// LCDޯ̧3'N'ݒ
		LCD_putc(4, '0');						// LCDޯ̧5'0'ݒ
		LCD_putc(5, 48 + FanNumber);			// LCDޯ̧6ɑΉ̧ݔԍݒ
		LCD_UpdateRequired(TRUE, 0);			// LCD\XV
	  }
	  else										// Ļ݂ȂŁA
	  {
		FanTemp = 0;							// ̧݉x()=0ݒ
		FanRPS = 0;								// ̧݉](RPS)=0ݒ
		LCD_putc(0, 'N');						// LCDޯ̧1'N'ݒ
		LCD_putc(1, 'O');						// LCDޯ̧2'O'ݒ
		LCD_putc(3, 'F');						// LCDޯ̧4'F'ݒ
		LCD_putc(4, 'A');						// LCDޯ̧5'A'ݒ
		LCD_putc(5, 'N');						// LCDޯ̧6'N'ݒ
		LCD_UpdateRequired(TRUE, 0);			// LCD\XV
	  }
	  break;
	case 11:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  if (FanNumber == 0)						// Ļ݂ȂŁA
		Cycle = 0;								// Ԕԍِݒ
	  break;
	case 12:
	  if (FanTemp < 0)							// ̧݉x-ŁA
	  {
		CH = CHAR2BCD2(-FanTemp);				// xl+Ƃ2lߍBCDϊ
		LCD_putc(0, '-');						// LCDޯ̧1'-'ݒ
	  }
	  else										// ̧݉x+ŁA
	  {
		CH = CHAR2BCD2(FanTemp);				// xl2lߍBCDϊ
		LCD_putc(0, '+');						// LCDޯ̧1'+'ݒ
	  }
	  CL = (CH & 0x0F) + '0';					// x1̌l擾
	  CH = (CH >> 4) + '0';						// x10̌l擾
	  LCD_putc(1, CH);							// LCDޯ̧2ɉx10̌ݒ
	  LCD_putc(2, CL);							// LCDޯ̧3ɉx1̌ݒ
	  LCD_putc(4, '.');							// LCDޯ̧5'.'ݒ
	  LCD_putc(5, 'C');							// LCDޯ̧6'C'ݒ
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 22:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 23:
	  CH = CHAR2BCD2(FanRPS);					// ](RPS)l2lߍBCDϊ
	  CL = (CH & 0x0F) + '0';					// ]1̌l擾
	  CH = (CH >> 4) + '0';						// ]10̌l擾
	  LCD_putc(0, CH);							// LCDޯ̧1ɉ]10̌ݒ
	  LCD_putc(1, CL);							// LCDޯ̧2ɉ]1̌ݒ
	  LCD_putc(3, 'R');							// LCDޯ̧4'R'ݒ
	  LCD_putc(4, 'P');							// LCDޯ̧5'P'ݒ
	  LCD_putc(5, 'S');							// LCDޯ̧6'S'ݒ
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 33:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 43:
	  Cycle = 0;								// Ԕԍِݒ
	  break;
  }
  Cycle++;										// Ԕԍis
  return ST_STATUS_FUNC;						// sԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: FanMonitor
//* 	: char input (ޮè)
//* Ԃl	: char ST_state (ԋ@\pԔԍ)
//* ړI	: Ǐ̧݂pIȏԍXVƕ\
//*
//*****************************************************************************
char FanMonitor(char input)
{
  static char Cycle, Enter = 1;					// Ԍv, ׸
  static signed char FanTemp;					// ̧݉x
  static unsigned char FanNumber, FanRPS;		// ̧ݔԍ,̧݉]
  unsigned char CH, CL;							// Ɨp

  Delay(100);									// 100msx
  if (Enter)									/* 񏈗 */
  {
	LCD_Clear();								// LCD󔒕\
	LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	FanNumber = 1;								// ̧ݔԍl
	FanTemp = 0;								// ̧݉xl
	FanRPS = 0;									// ̧݉]l
	Cycle = 1;									// Ԍv평(Jn)
	Enter = 0;									// ׸މ
  }

  switch (input)								/* ޮèˑ */
  {
	case  KEY_ENTER:							/*  */
	case  KEY_PLUS:								/*  */
	case  KEY_NEXT:								/*  */
	  if (FanNumber < 8)						// ̧ݔԍŁA
		FanNumber++;							// ̧ݔԍis
	  else										// ̧ݔԍŁA
		FanNumber = 1;							// ̧ݔԍ(=1ݒ)
	  Cycle = 1;								// Ԍv평(Jn)
	  break;
	case  KEY_MINUS:							/*  */
	case  KEY_PREV:								/*  */
	  FanNumber--;								// ̧ݔԍ
	  Cycle = 1;								// Ԍv평(Jn)
	  break;
  }
  if (FanNumber == 0)							// ̧ݔԍ=0ŁA
  {
	Enter = 1;									// ׸ސݒ(񏉊s)
	return ST_MONITOR;							// P̧ݓ\ԔԍƋɕA
  }

  switch (Cycle)								/* ԍˑ */
  {
	case 1:
	  LCD_putc(0, 'F');							// LCDޯ̧1'F'ݒ
	  LCD_putc(1, 'A');							// LCDޯ̧2'A'ݒ
	  LCD_putc(2, 'N');							// LCDޯ̧3'N'ݒ
	  LCD_putc(3, ' ');							// LCDޯ̧4ɋ󔒕ݒ
	  LCD_putc(4, '0');							// LCDޯ̧5'0'ݒ
	  LCD_putc(5, 48 + FanNumber);				// LCDޯ̧6ɑΉ̧ݔԍݒ
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 2:
	  FanTemp = FanTemperature(FanNumber);		// Ή̧݉x()擾
	  break;
	case 3:
	  if (FanTemp == 0)							// Ή̧݉x=0ŁA
		FanRPS = 0;								// Ή̧݉]=0ݒ
	  else										// Ή̧݉x0ŁA
		FanRPS = FanSpeed(FanNumber);			// Ή̧݉](RPS)擾
	  break;
	case 11:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 12:
	  if (FanTemp == 0)							// Ή̧݉xŁA
	  {
		LCD_putc(0, ' ');						// LCDޯ̧1ɋ󔒕ݒ
		LCD_putc(1, ' ');						// LCDޯ̧2ɋ󔒕ݒ
		LCD_putc(2, 'N');						// LCDޯ̧3'N'ݒ
		LCD_putc(3, 'A');						// LCDޯ̧4'A'ݒ
		LCD_putc(4, ' ');						// LCDޯ̧5ɋ󔒕ݒ
		LCD_putc(5, ' ');						// LCDޯ̧6ɋ󔒕ݒ
	  }
	  else										// Ή̧݉xLŁA
	  {
		if (FanTemp < 0)						// ̧݉x-ŁA
		{
		  CH = CHAR2BCD2(-FanTemp);				// xl+Ƃ2lߍBCDϊ
		  LCD_putc(0, '-');						// LCDޯ̧1'-'ݒ
		}
		else									// ̧݉x+ŁA
		{
		  CH = CHAR2BCD2(FanTemp);				// xl2lߍBCDϊ
		  LCD_putc(0, '+');						// LCDޯ̧1'+'ݒ
		}
		CL = (CH & 0x0F) + '0';					// x1̌l擾
		CH = (CH >> 4) + '0';					// x10̌l擾
		LCD_putc(1, CH);						// LCDޯ̧2ɉx10̌ݒ
		LCD_putc(2, CL);						// LCDޯ̧3ɉx1̌ݒ
		LCD_putc(4, '.');						// LCDޯ̧5'.'ݒ
		LCD_putc(5, 'C');						// LCDޯ̧6'C'ݒ
	  }
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 22:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  if (FanTemp == 0)							// Ή̧݉](܂͒~)ŁA
		Cycle = 0;								// Ԕԍِݒ
	  break;
	case 23:
	  CH = CHAR2BCD2(FanRPS);					// ]l2lߍBCDϊ
	  CL = (CH & 0x0F) + '0';					// ]1̌l擾
	  CH = (CH >> 4) + '0';						// ]10̌l擾
	  LCD_putc(0, CH);							// LCDޯ̧1ɉ]10̌ݒ
	  LCD_putc(1, CL);							// LCDޯ̧2ɉ]1̌ݒ
	  LCD_putc(3, 'R');							// LCDޯ̧4'R'ݒ
	  LCD_putc(4, 'P');							// LCDޯ̧5'P'ݒ
	  LCD_putc(5, 'S');							// LCDޯ̧6'S'ݒ
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 33:
	  LCD_Clear();								// LCD󔒕\
	  LCD_UpdateRequired(TRUE, 0);				// LCD\XV
	  break;
	case 43:
	  Cycle = 0;								// Ԕԍِݒ
	  break;
  }
  Cycle++;										// Ԕԍis
  return ST_MONITOR_FUNC;						// P̧ݓsԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: FanThrottle
//* 	: char input (ޮè)
//* Ԃl	: char ST_state (ԋ@\pԔԍ)
//* ړI	: Şݐߓ_(ɰ)ɑ΂鉓u
//*
//*****************************************************************************
char FanThrottle(char input)
{
  static char enter = 1;				// ׸
  static unsigned char FanNumber = 1, FanChange = TRUE, targetRPS = 20;		// ̧ݔԍ,̧ݕύX׸,ݒ̧݉]
  unsigned char messageBuf[MESSAGEBUF_SIZE];	// USI_TWIү ޯ̧
  unsigned char CH, CL, temp;			// Ɨp

  if (enter)							/* 񏈗 */
  {
	LCD_Clear();						// LCD󔒕\
	LCD_Colon(TRUE);					// LCD(:)\
	enter = 0;							// ׸މ
  }

  if (FanNumber == 0)					// Oƭւ̖߂wŁA
  {
	enter = 1;							// ׸ސݒ
	FanNumber = 1;						// ̧ݔԍ
	LCD_Colon(FALSE);					// LCD(:)\
	LCD_UpdateRequired(TRUE, 0);		// LCD\XV
	return ST_THROTTLE;					// u쓮\ԔԍƋɕA
  }

  if (FanChange)						// ̧ݔԍXVLŁA
  {
	LCD_Clear();						// LCD󔒕\
	LCD_putc(0, 'F');					// LCDޯ̧1'F'ݒ
	LCD_putc(1, 48 + FanNumber);		// LCDޯ̧2̧ݔԍݒ
	LCD_putc(2, '-');					// LCDޯ̧3'-'ݒ
	LCD_putc(3, '-');					// LCDޯ̧4'-'ݒ
	LCD_putc(4, '-');					// LCDޯ̧5'-'ݒ
	LCD_putc(5, '-');					// LCDޯ̧6'-'ݒ
	LCD_UpdateRequired(TRUE, 0);		// LCD\XV
	FanChange = FALSE;					// ̧ݍXV׸މ

	gUSI = TRUE;						// USIgp׸ސݒ
	messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Wݒ
	messageBuf[1] = TWI_CMD_MASTER_READ;									// ʒuɎ呕uǂݍݖߕݒ
	temp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 2);				// USI_TWIүޑM
	messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);		// TWIү ޯ̧擪SLA+Rݒ
	Delay(100);																// 100msx
	if (USI_TWI_Start_Transceiver_With_Data(messageBuf, 2))					// USI_TWIүގM,ŁA
	  targetRPS = messageBuf[1];											// Mޯ̧猻]l擾
	else																	// sŁA
	  targetRPS = 0;														// ̧݉]=ݒ
	gUSI = FALSE;						// USIgp׸މ
  }

  switch (input)						/* ޮèˑ */
  {
	case KEY_NEXT:						/*  */
	  if (FanNumber < 8)				// ̧ݔԍŁA
		FanNumber++;					// ̧ݔԍis
	  else								// ̧ݔԍŁA
		FanNumber = 1;					// ̧ݔԍ(=1ݒ)
	  FanChange = TRUE;					// ̧ݕύX׸ސݒ
	  break;
	case KEY_PREV:						/*  */
	  FanNumber--;						// ̧ݔԍ
	  FanChange = TRUE;					// ̧ݕύX׸ސݒ
	  break;
	case KEY_PLUS:						/*  */
	  if (targetRPS < 100)				// ݒ]ŁA
		targetRPS++;					// ݒ]
	  break;
	case KEY_MINUS:						/*  */
	  if (targetRPS > 0)				// ݒ]zŁA
		targetRPS--;					// ݒ]
	  break;
	case KEY_ENTER:						/*  */
	  if (targetRPS > 0)				// ̧ݒ~ȊOŁA
		targetRPS = 0;					// ̧ݒ~(]=0)ݒ
	  else								// ̧ݒ~ŁA
		targetRPS = 1;					// x䓮아(]=1)ݒ
	  break;
  }

  gUSI = TRUE;							// USIgp׸ސݒ
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Wݒ
  messageBuf[1] = TWI_CMD_MASTER_READ;									// ʒuɎ呕uǂݍݖߕݒ
  temp = USI_TWI_Start_Transceiver_With_Data(messageBuf,2);				// USI_TWIүޑM
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Rݒ
  Delay(200);															// 200msx
  if (USI_TWI_Start_Transceiver_With_Data(messageBuf,3))				// USI_TWIүގM,ŁA
  {
	CH = CHAR2BCD2(messageBuf[2]);		// 擾]l2lߍBCDϊ
	CL = (CH & 0x0F) + '0';				// 擾]1̌l擾
	CH = (CH >> 4) + '0';				// 擾]10̌l擾
	LCD_putc(2, CH);					// LCDޯ̧3ɉ]10̌ݒ
	LCD_putc(3, CL);					// LCDޯ̧4ɉ]1̌ݒ
	switch (targetRPS)					/* ݒ󋵈ˑ */
	{
	  case 0:							/* ̧ݒ~ݒ */
		LCD_putc(4, 'S');				// LCDޯ̧5'S'ݒ
		LCD_putc(5, 'T');				// LCDޯ̧6'T'ݒ
		break;
	  case 1:							/* x䓮ݒ */
		LCD_putc(4, 'T');				// LCDޯ̧5'T'ݒ
		LCD_putc(5, 'M');				// LCDޯ̧6'M'ݒ
		break;
	  default:							/* u쓮ݒ */
		CH = CHAR2BCD2(targetRPS);		// ݒ]l2lߍBCDϊ
		CL = (CH & 0x0F) + '0';			// ݒ]1̌l擾
		CH = (CH >> 4) + '0';			// ݒ]10̌l擾
		LCD_putc(4, CH);				// LCDޯ̧5ɐݒ]10̌ݒ
		LCD_putc(5, CL);				// LCDޯ̧6ɐݒ]1̌ݒ
		break;
	}

	/* Ή̧ݐ֐ݒ](RPS)lM */
	messageBuf[0] = (FanNumber<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Wݒ
	messageBuf[1] = TWI_CMD_MASTER_WRITE;								// ʒuɎ呕uݖߕݒ
	messageBuf[2] = targetRPS;											// ̎̈ʒuɐݒ]lݒ
	temp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 3);			// USI_TWIүޑM
  }
  else									// USI_TWIүގM,sŁA
  {
	switch (USI_TWI_Get_State_Info())	/* ُԍˑ */
	{
	  case USI_TWI_NO_DATA:				/* Mޯ̧ */
	  case USI_TWI_DATA_OUT_OF_BOUND:	/* SRAMOMޯ̧ */
	  case USI_TWI_UE_START_CON:		/* \ʊJn */
	  case USI_TWI_UE_STOP_CON:			/* \ʒ~ */
	  case USI_TWI_UE_DATA_COL:			/* \ް㏑(┭) */
	  case USI_TWI_MISSING_START_CON:	/* ޽ł̊JnmF */
	  case USI_TWI_MISSING_STOP_CON:	/* ޽ł̒~mF */
	  case USI_TWI_NO_ACK_ON_DATA:		/* ]uSް ߹Ė */
		LCD_putc(2, 'E');				// LCDޯ̧3'E'ݒ
		LCD_putc(3, '0' + USI_TWI_Get_State_Info());	// LCDޯ̧4Ɉُԍݒ
		LCD_putc(4, '-');				// LCDޯ̧5'-'ݒ
		LCD_putc(5, '-');				// LCDޯ̧6'-'ݒ
		break;
	  case  USI_TWI_NO_ACK_ON_ADDRESS:	/* ]uڽ ߹Ė */
		LCD_putc(2, 'N');				// LCDޯ̧3'N'ݒ
		LCD_putc(3, 'A');				// LCDޯ̧4'A'ݒ
		LCD_putc(4, '-');				// LCDޯ̧5'-'ݒ
		LCD_putc(5, '-');				// LCDޯ̧6'-'ݒ
		break;
	}
  }
  LCD_UpdateRequired(TRUE, 0);			// LCD\XV
  gUSI = FALSE;							// USIgp׸މ
  return ST_THROTTLE_FUNC;				// usԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: FanNext
//* 	: char FanStart (̧ݔԍ)
//* Ԃl	: char (̧ݔԍ)
//* ړI	: ɗp\̧݂TWIڽԍԂ܂B0̧݂Ȃ
//*			  ƂӖ܂B
//*
//*****************************************************************************
char FanNext(char FanStart)
{
  unsigned char FanNumber;						// ̧ݔԍ(=TWIڽ)

  FanNumber = FanStart;							// ̧ݔԍ擾
  while(1)
  {
	FanNumber++;								// ̧ݔԍis
	if (FanNumber > 8)							// 8zŁA
	{
	  FanNumber = 1;							// ̧ݔԍ=1
	  if ((FanStart < 1) | (FanStart > 8))		// ̧ݔԍ1`8ȊO̧݂ȂƂĕA
		return 0;
	}
	if (FanTemperature(FanNumber))				// Ή̧݉xl擾ŁA
	  return FanNumber;							// ̗ĻݔԍƋɕA
	if (FanNumber == FanStart)					// 1IŁA
	  return 0;									// Ļ݂ȂƋɕA
	Delay(50);									// 50msҋ@(]u\Ԋm)
  }
}

//*****************************************************************************
//*
//* ֐	: FanTemperature
//* 	: char FanNumber (̧ݔԍ)
//* Ԃl	: signed char (̧݉x)
//* ړI	: ̧݂̉xԂ܂B0ُ͈킪邱ƂӖ܂B
//*
//*****************************************************************************
signed char FanTemperature(char FanNumber)
{
  unsigned char messageBuf[MESSAGEBUF_SIZE];							// TWIү ޯ̧
  unsigned char utemp;													// USI_TWI]
  signed char stemp;													// ̧݉x

  DDRB |= 0x01;															//

  gUSI = TRUE;															// USIgp׸ސݒ
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Wݒ
  messageBuf[1] = TWI_CMD_MASTER_READ;									// ʒuɎ呕uǂݍݖߕݒ
  utemp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 2);			// USI_TWIүޑM
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Rݒ
  utemp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 3);			// USI_TWIүގM
  gUSI = FALSE;															// USIgp׸މ
  if (!utemp)															// USI_TWI]sŁA
  {
	return 0;															// ُ필ƋɕA
  }
  else																	// USI_TWI]ŁA
  {
	stemp = (signed char) messageBuf[1];								// Mޯ̧̧݉x()l擾
	if (stemp < -99)													// -99ŁA-99ɋ
	  stemp = -99;
	if (stemp > 99)														// 99zŁA99ɋ
	  stemp = 99;
	return stemp;														// ̧݉x()lƋɕA
  }
}

//*****************************************************************************
//*
//* ֐	: FanSpeed
//* 	: char FanNumber (̧ݔԍ)
//* Ԃl	: char (̧݉])
//* ړI	: ̧݂̉]Ԃ܂B0ُ͈킪邱ƂӖ܂B
//*
//*****************************************************************************
char FanSpeed(char FanNumber)
{
  unsigned char messageBuf[MESSAGEBUF_SIZE];							// TWIү ޯ̧
  unsigned char utemp;													// USI_TWI]
  signed char stemp;													// ̧݉]

  gUSI = TRUE;															// USIgp׸ސݒ
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Wݒ
  messageBuf[1] = TWI_CMD_MASTER_READ;									// ʒuɎ呕uǂݍݖߕݒ
  utemp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 2);			// USI_TWIүޑM
  messageBuf[0] = (FanNumber << TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);	// TWIү ޯ̧擪SLA+Rݒ
  utemp = USI_TWI_Start_Transceiver_With_Data(messageBuf, 3);			// USI_TWIүގM
  gUSI = FALSE;															// USIgp׸މ
  if (!utemp)															// USI_TWI]sŁA
  {
	return 0;															// ُ필ƋɕA
  }
  else																	// USI_TWI]ŁA
  {
	stemp = (signed char) messageBuf[2];								// Mޯ̧̧݉](RPS)l擾
	if (stemp < 0)														// 0ŁA0ɋ
	  stemp = 0;
	if (stemp > 99)														// 99zŁA99ɋ
	  stemp = 99;
	return stemp;														// ̧݉](RPS)lƋɕA
  }
}
