/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: USI_TWI_Master.c
* ߲		: IAR EWAAVR 4.10B
* 			: $Revision: 1.81 $
* t			: $Date: 18.03.2005 $
* XV		: $Author: LTWA, KMe $
*
* xҰ		: avr@atmel.com
*
* x޲	: {ATmega169pɏĂ܂B
*
* pLq		: AVR310 - TWI呕uƂĂUSI̎g
*
* 			: USIbƂĎgpTWI呕u̎łB
*				  ѓ̗BTWI呕ułAVRƉ肵A]ĕ呕u
*				  тgp邱Ƃ͂ł܂B
* g		: USI_TWI_Master_Initialize()֐ĂяoƂɂUSI
*				  ĂB̌Aү/ްUSI_Master_Trans-
*				  fer()֐gp޽őM܂BM͏޲
*				  ԂAĂ͓]̌ʂ]̂ɗp邱Ƃł
*				  ܂B
*
****************************************************************************/

#include <inavr.h>
#include <ioavr.h>

#include "main.h"
#include "USI_TWI_Master.h"

unsigned char USI_TWI_Master_Transfer( unsigned char );
unsigned char USI_TWI_Master_Stop( void );

union  USI_TWI_state
{
  unsigned char errorState;		// ُ킪݂ꍇɕKvƂȂ̂ňُԗpTWI_stateĎgp邱Ƃł܂B
  struct
  {
    unsigned char addressMode         : 1;	// ߹Ď׸(ڽ=^,ް=U)
    unsigned char masterWriteDataMode : 1;	// 呕uǂ/׸(=^,ǂ=U)
    unsigned char unused              : 6;
  };
}   USI_TWI_state;

#pragma vector = USI_STRT_vect
__interrupt void USI_START_ISR(void)
{
  USISR |= (1<<USISIF);					// Jno׸މ(Jn)
}

/*-----------------------------------------------------------------------------
 USI TWIPƎ呕u֐
-----------------------------------------------------------------------------*/
void USI_TWI_Master_Initialize( void )
{
  PORT_USI |= (1<<PIN_USI_SDA);			// SDA=Jlݒ
  PORT_USI |= (1<<PIN_USI_SCL);			// SCL=Jlݒ

  DDR_USI  |= (1<<PIN_USI_SCL);			// SCLo͐ݒ
  DDR_USI  |= (1<<PIN_USI_SDA);			// SDAo͐ݒ

  USIDR    =  0xFF;						// MlƂĊJԒlOݒ
  USICR    =  (1<<USISIE)|(0<<USIOIE)|							// USI荞݋֎~
              (1<<USIWM1)|(0<<USIWM0)|							// 2w
              (1<<USICS1)|(0<<USICS0)|(1<<USICLK)|				// ĳ ۯƂɂvɐݒ
              (0<<USITC);
  USISR   =   (1<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// e׸މ
              (0x0<<USICNT0);									// v
}

/*-----------------------------------------------------------------------------
 Ō̓]ŕێĂُүނ𓾂ɂ͂̊֐gpĂB
-----------------------------------------------------------------------------*/
unsigned char USI_TWI_Get_State_Info( void )
{
  return ( USI_TWI_state.errorState );	// ُԂƋɕA
}

/*-----------------------------------------------------------------------------
 USIM֐Bޯ̧ް̐擪޲ĂLSB͓ǂݍ݂܂͏݂̂ǂ炪
 s邩܂Bݒ(1)ȂΓǂݍݑ삪s܂B

 ֐(đ)Jn𐶐AڽR/W𑗂Aްǂ(M)/(M)
 āAĉ((N)ACK)/M܂B

 ܂ُ͈필Ԃ܂Bُ필USI_TWI_Master.hŒ`Ă܂B
-----------------------------------------------------------------------------*/
__x unsigned char USI_TWI_Start_Transceiver_With_Data( unsigned char *msg, unsigned char msgSize)
{
  unsigned char tempUSISR_8bit = (1<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// 8ޯėpUSISRl: e׸މ
								 (0x0<<USICNT0);								// v평(8ޯĂ8~2=16,ݒl16-16=0)
  unsigned char tempUSISR_1bit = (1<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// 1ޯėpUSISRl: e׸މ
								 (0xE<<USICNT0);								// v평(1ޯĂ1~2=2,ݒl16-2=14)

  USI_TWI_state.errorState = 0;			// ُԔԍ
  USI_TWI_state.addressMode = TRUE;		// ڽ/ް ߹Ď׸ޏ(ڽ)

#ifdef PARAM_VERIFICATION		// ]ޯ̧
  if(msg > (unsigned char*)RAMEND)							// ]ޯ̧擪SRAMzĂ΁A
  {
	USI_TWI_state.errorState = USI_TWI_DATA_OUT_OF_BOUND;	// SRAM͈͊Oُ필ݒ
	return (FALSE);
  }
  if(msgSize <= 1)											// ޯ̧޲Đ=0wŁA
  {
	USI_TWI_state.errorState = USI_TWI_NO_DATA;				// ޯُ̧필ݒ
	return (FALSE);
  }
#endif

#ifdef NOISE_TESTING			// sɐ旧\ʏ𒲍
  if( USISR & (1<<USISIF) )				// Jno荞ݗv׸=1ŁA
  {
	USI_TWI_state.errorState = USI_TWI_UE_START_CON;		// \ʊJnُ필ݒ
	return (FALSE);
  }
  if( USISR & (1<<USIPF) )									// ~o荞ݗv׸=1ŁA
  {
	USI_TWI_state.errorState = USI_TWI_UE_STOP_CON;			// \ʒ~ُ필ݒ
	return (FALSE);
  }
  if( USISR & (1<<USIDC) )									// o͒lՓ˔׸=1ŁA
  {
	USI_TWI_state.errorState = USI_TWI_UE_DATA_COL;			// ްُ필ݒ
	return (FALSE);
  }
#endif

  if ( !(*msg & (1<<TWI_READ_BIT)) )			// R/Wޯ=0()ŁA
  {
	USI_TWI_state.masterWriteDataMode = TRUE;	// 呕uݓ׸ސݒ
  }

  PORT_USI |= (1<<PIN_USI_SCL);					// SCL=J(H),((đ)Jns\ȂƂۏ؂邽)
  while( !(PORT_USI & (1<<PIN_USI_SCL)) );		// SCL=H؊mF
#ifdef TWI_FAST_MODE
  __delay_cycles( T4_TWI );						// 쎞ASCL(đ)Jnxҋ@
#else
  __delay_cycles( T2_TWI );						// W쎞ASCL(đ)Jnxҋ@
#endif

  /* iđ)Jno */
  PORT_USI &= ~(1<<PIN_USI_SDA);				// SDA=Lowݒ((đ)Jn)
  __delay_cycles( T4_TWI );						// (đ)JnSCL=Hێԑҋ@
  PORT_USI &= ~(1<<PIN_USI_SCL);				// SCL=Lowݒ
  PORT_USI |= (1<<PIN_USI_SDA);					// SDA=J(H)

#ifdef SIGNAL_VERIFY			// (đ)Jn/~
  if( !(USISR & (1<<USISIF)) )								// (đ)Jno荞ݗv׸=0ŁA
  {
	USI_TWI_state.errorState = USI_TWI_MISSING_START_CON;	// (đ)Jnoُ필ݒ
	return (FALSE);
  }
#endif

  /* ڽ ߹đoް ߹đM */
  do
  {
	if (USI_TWI_state.addressMode || USI_TWI_state.masterWriteDataMode)		// ڽ ߹Ă呕uݓްMŁA
	{
	  /* ( ޲đM ) */
	  PORT_USI &= ~(1<<PIN_USI_SCL);				// SCL=Lowݒ
	  USIDR     = *(msg++);							// o޲Ēlݒ
	  USI_TWI_Master_Transfer( tempUSISR_8bit );	// 8ޯđM

	  /* ( ]u(N)ACKM ) */
	  DDR_USI  &= ~(1<<PIN_USI_SDA);				// SDA͐ݒ
	  if( USI_TWI_Master_Transfer( tempUSISR_1bit ) & (1<<TWI_NACK_BIT) )	// 1ޯĎMŔے艞ȂA
	  {
		if ( USI_TWI_state.addressMode )							// ڽ ߹ĂŁA
		  USI_TWI_state.errorState = USI_TWI_NO_ACK_ON_ADDRESS;		// ]uڽے艞ݒ
		else														// ް ߹ĂŁA
		  USI_TWI_state.errorState = USI_TWI_NO_ACK_ON_DATA;		// ]uްے艞ݒ
		return (FALSE);
	  }
	  USI_TWI_state.addressMode = FALSE;			// ߹Ďʂް ߹Ăɐݒ(ڽM1xs)
	}
	else																	// 呕uǂݍݓްMŁA
	{
	  /* ( ޲ĎM ) */
	  DDR_USI   &= ~(1<<PIN_USI_SDA);				// SDA͐ݒ
	  *(msg++)  = USI_TWI_Master_Transfer( tempUSISR_8bit );		// 8ޯĎM
	  if( msgSize == 1)								// ŏIް ߹ĂŁA
	  {
		USIDR = 0xFF;								// NACKlݒ(ǂݍݏI\)
	  }
	  else											// ŏIް ߹ĈȊOŁA
	  {
		USIDR = 0x00;								// ACKlݒ(ǂݍ݌p\)
	  }
	  USI_TWI_Master_Transfer( tempUSISR_1bit );	// 1ޯđM((N)ACK)
	}
  }while( --msgSize) ;								// ޯ̧ ߲is,ްM܂Ōp

  USI_TWI_Master_Stop();							// ~o
  return (TRUE);									// ׸ނƋɌĂяo֕A
}

/*-----------------------------------------------------------------------------
 USIłް ēo͗p̒j֐B
 Mް͂̊֐ĂяoOUSIDRɔzuȂ΂Ȃ܂BMް
 ͂̊֐Ԃ܂B
 () ~o܂ŁÅ֐ĂяoԂSCLLowێ̂܂܂ɂȂ邱Ƃɒ
		ӂĂB
-----------------------------------------------------------------------------*/
unsigned char USI_TWI_Master_Transfer( unsigned char temp )
{
  USISR = temp;										// `ς̸݂ۯ,vlɏ]USISRݒ
  temp  =  (1<<USISIE)|(0<<USIOIE)|					// USI荞݋֎~
		   (1<<USIWM1)|(0<<USIWM0)|					// 2USI
		   (1<<USICS1)|(0<<USICS0)|(1<<USICLK)|		// ĳ ۯ ۰
		   (1<<USITC);								// ۯݐ؂ւA̎wl擾
  do
  {
	__delay_cycles( T2_TWI );					// SCLŏLowԎԒx
	USICR = temp;								// SCL=J(H)ݒ(SCL)
	while( !(PIN_USI & (1<<PIN_USI_SCL)) );		// SCL=HmF܂őҋ@
	__delay_cycles( T4_TWI );					// SCLŏHighԎԒx
	USICR = temp;								// SCL=Lݒ(SCL)
  }while( !(USISR & (1<<USIOIF)) );				// wޯĐ܂Ōp

  __delay_cycles( T2_TWI );			// SCLŏLowԎԒx
  temp  = USIDR;					// Ml擾
  USIDR = 0xFF;						// SDAJ(H)lw
  DDR_USI |= (1<<PIN_USI_SDA);		// SDAo͐ݒ
  return temp;						// MlƋɌĂяo֕A
}

/*-----------------------------------------------------------------------------
 TWI~p֐BTWI޽ĴɎgpĂB
-----------------------------------------------------------------------------*/
unsigned char USI_TWI_Master_Stop( void )
{
  PORT_USI &= ~(1<<PIN_USI_SDA);			// SDA=Lowݒ
  PORT_USI |= (1<<PIN_USI_SCL);				// SCL=J(H)ݒ(SCL)
  while( !(PIN_USI & (1<<PIN_USI_SCL)) );	// SCL=HmF܂őҋ@
  __delay_cycles( T4_TWI );					// SCLSDA=LowێԒx
  PORT_USI |= (1<<PIN_USI_SDA);				// SDA=J(H)ݒ(SDA)
  __delay_cycles( T2_TWI );					// SDASCL=HighێԒx

#ifdef SIGNAL_VERIFY			// (đ)Jn/~
  if( !(USISR & (1<<USIPF)) )								// ~o荞ݗv׸=0ŁA
  {
	USI_TWI_state.errorState = USI_TWI_MISSING_STOP_CON;	// ~oُ필ݒ
	return (FALSE);
  }
#endif

  return (TRUE);
}
